/***************************************************************************
 *   Copyright (C) 2009 by Mirko Lindner,,,   *
 *   vegyraupe@mira   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// newer (non customized) versions of this file go to main_window.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "main_window.hh"
#include "vido.hh"
#include <cxxtools/log.h>

log_define("vido.main_window");

main_window::main_window()
{ 
    signal_key_press_event().connect(sigc::mem_fun(*this,&main_window::on_my_key_press_event));
    signal_key_release_event().connect(sigc::mem_fun(*this,&main_window::on_my_key_release_event)); 
}

bool main_window::actions(int key)
{
    static int key_b = 98;
    static int key_f = 102;
    static int key_h = 104;
    static int key_q = 113;
    static int key_r = 114;
    static int key_s = 115;
    static int key_t = 116;

    if (key == key_q)
    {
        log_debug("quit requested");
        quit();
    }
    else if(key == key_r)
    {
        log_debug("random");
        show_random();
    }
    else if(key == key_s)
    {
        log_debug("search");
        search_window(this);
    }else if(key == key_t){
        GoToTop();
    }else if(key == key_h){
        show_history();
    }else if(key == key_f){
        history_jump(1);
    }else if(key == key_b){
        history_jump(-1);
    }else{
      log_debug("key pressed: " << key);
    }
    
    return true; 

}

bool main_window::on_my_key_press_event(GdkEventKey *Key) 
{ 
    if (Key->keyval == gdk_keyval_from_name("Control_R"))
    {
        ctrl_state = 1;
    }
    else
    {
      if (ctrl_state == 1)
      {
          actions(Key->keyval);
      }
    }

    log_debug("Key Presssed is " << gdk_keyval_name(Key->keyval)); 
    return true; 
} 

bool main_window::on_my_key_release_event(GdkEventKey *Key) 
{ 
    if (Key->keyval == gdk_keyval_from_name("Control_R"))
    {
        ctrl_state = 0;
    }

    return true; 
} 

bool main_window::quit()
{  
    hide();
    return false;
}
